
/*  A Bison parser, made from parser.bison
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tVRML	257
#define	tNODECATALOG	258
#define	tDEF	259
#define	tNAME	260
#define	tUSE	261
#define	tPROTO	262
#define	teventIn	263
#define	teventOut	264
#define	tfield	265
#define	texposedField	266
#define	tROUTE	267
#define	tTO	268
#define	tIS	269
#define	tEXTERNPROTO	270
#define	tTRUE	271
#define	tFALSE	272
#define	tNULL	273
#define	tScript	274
#define	tSIMPLEFIELD	275
#define	tSFNODE	276
#define	tMFNODE	277
#define	tID	278
#define	tSTRING	279
#define	tFLOAT	280
#define	tINT	281
#define	tHEX	282

#line 4 "parser.bison"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define _VRML2_UTF8_PARSER_SOURCE_

#include "parser.H"

namespace vrml2_utf8 {

#define yyparse parser::yyparse
#define yylex parser::yylex
#define yyerror parser::yyerror
#define yylval parser::yylval
#define yychar parser::yychar
#define yydebug parser::yydebug
#define yynerrs parser::yynerrs




#define YY_OMIT_DECLS

#line 28 "parser.bison"










#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		190
#define	YYFLAG		-32768
#define	YYNTBASE	34

#define YYTRANSLATE(x) ((unsigned)(x) <= 282 ? yytranslate[x] : 80)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    33,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    31,     2,    32,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    29,     2,    30,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     7,     9,    12,    15,    16,    18,    20,
    22,    24,    28,    32,    34,    37,    39,    41,    43,    45,
    48,    51,    52,    57,    63,    67,    69,    72,    75,    76,
    80,    84,    87,    89,    92,    96,   100,   104,   108,   115,
   117,   120,   123,   124,   128,   132,   136,   140,   149,   151,
   156,   161,   163,   165,   167,   170,   171,   173,   175,   178,
   181,   184,   187,   192,   195,   200,   202,   207,   212,   217,
   219,   222,   225,   226,   228,   232,   234,   236,   239,   243,
   247,   250,   253,   255,   257,   259,   261,   263,   265,   267,
   269,   271,   273,   275,   277,   279,   281,   283,   285,   287,
   290,   294,   296,   299,   301,   303,   305,   308,   312,   314
};

static const short yyrhs[] = {    35,
    36,     0,     3,     0,    37,     0,    38,     0,    38,    37,
     0,     1,    37,     0,     0,    40,     0,    41,     0,    53,
     0,    55,     0,     5,    67,    55,     0,     6,    67,    55,
     0,    39,     0,     7,    67,     0,    19,     0,    43,     0,
    50,     0,    41,     0,    41,    42,     0,     1,    42,     0,
     0,    44,    29,    45,    30,     0,     8,    68,    31,    46,
    32,     0,    42,    39,    37,     0,    48,     0,    48,    46,
     0,     1,    46,     0,     0,     9,    73,    70,     0,    10,
    73,    71,     0,    11,    49,     0,    47,     0,    12,    49,
     0,    22,    69,    77,     0,    23,    69,    75,     0,    21,
    69,    31,     0,    21,    69,    74,     0,    16,    68,    31,
    51,    32,    54,     0,    52,     0,    52,    51,     0,     1,
    51,     0,     0,     9,    73,    70,     0,    10,    73,    71,
     0,    11,    73,    69,     0,    12,    73,    69,     0,    13,
    67,    33,    71,    14,    67,    33,    70,     0,    78,     0,
    56,    29,    58,    30,     0,    57,    29,    64,    30,     0,
    20,     0,    68,     0,    59,     0,    59,    58,     0,     0,
    60,     0,    65,     0,     9,    61,     0,    10,    62,     0,
    11,    63,     0,    73,    70,     0,    73,    70,    15,    70,
     0,    73,    71,     0,    73,    71,    15,    71,     0,    49,
     0,    22,    69,    15,    69,     0,    23,    69,    15,    69,
     0,    21,    69,    15,    69,     0,    65,     0,    65,    64,
     0,     1,    64,     0,     0,    66,     0,    72,    15,    72,
     0,    53,     0,    41,     0,    69,    74,     0,    69,    31,
    74,     0,    69,    31,    32,     0,    69,    77,     0,    69,
    75,     0,    72,     0,    72,     0,    20,     0,    72,     0,
    72,     0,    72,     0,    24,     0,    21,     0,    22,     0,
    23,     0,    17,     0,    18,     0,    25,     0,    26,     0,
    27,     0,    28,     0,    40,     0,    31,    32,     0,    31,
    76,    32,     0,    40,     0,    76,    40,     0,    40,     0,
    19,     0,    25,     0,    31,    32,     0,    31,    79,    32,
     0,    25,     0,    79,    25,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    53,    55,    60,    62,    63,    64,    65,    67,    68,    69,
    71,    75,    79,    84,    85,    89,    94,    95,    97,    98,
    99,   100,   102,   107,   112,   114,   115,   116,   117,   119,
   124,   128,   132,   133,   138,   144,   149,   155,   162,   167,
   168,   169,   170,   172,   176,   180,   184,   189,   194,   198,
   202,   207,   212,   217,   218,   219,   221,   222,   224,   226,
   227,   229,   233,   238,   242,   247,   251,   255,   259,   264,
   265,   266,   267,   269,   270,   274,   275,   277,   281,   285,
   289,   293,   298,   300,   301,   306,   308,   310,   312,   316,
   317,   318,   320,   320,   320,   320,   320,   320,   322,   326,
   330,   335,   339,   344,   348,   353,   357,   361,   366,   370
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tVRML",
"tNODECATALOG","tDEF","tNAME","tUSE","tPROTO","teventIn","teventOut","tfield",
"texposedField","tROUTE","tTO","tIS","tEXTERNPROTO","tTRUE","tFALSE","tNULL",
"tScript","tSIMPLEFIELD","tSFNODE","tMFNODE","tID","tSTRING","tFLOAT","tINT",
"tHEX","'{'","'}'","'['","']'","'.'","file","vrmlHeader","vrmlScene","statements",
"statement","rootNodeStatement","nodeStatement","protoStatement","protoStatements",
"proto","protoInterface","protoBody","interfaceDeclarations","restrictedInterfaceDeclaration",
"interfaceDeclaration","fieldTypeIdValueTriple","externproto","externInterfaceDeclarations",
"externInterfaceDeclaration","routeStatement","URLList","node","scriptNodeTypeId",
"otherNodeTypeId","scriptBody","scriptBodyElement","scriptInterfaceDeclaration",
"scriptEventInDeclaration","scriptEventOutDeclaration","scriptFieldDeclaration",
"nodeBody","nodeBodyElement","fieldIdValuePair","nodeNameId","nodeTypeId","fieldId",
"eventInId","eventOutId","Id","fieldType","fieldValueAtom","mfnodeValue","nodeStatements",
"sfnodeValue","mfstringValue","strings", NULL
};
#endif

static const short yyr1[] = {     0,
    34,    35,    36,    37,    37,    37,    37,    38,    38,    38,
    39,    39,    39,    40,    40,    40,    41,    41,    42,    42,
    42,    42,    43,    44,    45,    46,    46,    46,    46,    47,
    47,    47,    48,    48,    49,    49,    49,    49,    50,    51,
    51,    51,    51,    52,    52,    52,    52,    53,    54,    55,
    55,    56,    57,    58,    58,    58,    59,    59,    60,    60,
    60,    61,    61,    62,    62,    63,    63,    63,    63,    64,
    64,    64,    64,    65,    65,    65,    65,    66,    66,    66,
    66,    66,    67,    68,    68,    69,    70,    71,    72,    73,
    73,    73,    74,    74,    74,    74,    74,    74,    75,    75,
    75,    76,    76,    77,    77,    78,    78,    78,    79,    79
};

static const short yyr2[] = {     0,
     2,     1,     1,     1,     2,     2,     0,     1,     1,     1,
     1,     3,     3,     1,     2,     1,     1,     1,     1,     2,
     2,     0,     4,     5,     3,     1,     2,     2,     0,     3,
     3,     2,     1,     2,     3,     3,     3,     3,     6,     1,
     2,     2,     0,     3,     3,     3,     3,     8,     1,     4,
     4,     1,     1,     1,     2,     0,     1,     1,     2,     2,
     2,     2,     4,     2,     4,     1,     4,     4,     4,     1,
     2,     2,     0,     1,     3,     1,     1,     2,     3,     3,
     2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     3,     1,     2,     1,     1,     1,     2,     3,     1,     2
};

static const short yydefact[] = {     0,
     2,     0,     0,     0,     0,     0,     0,     0,     0,    16,
    52,    89,     1,     3,     0,    14,     8,     9,    17,     0,
    18,    10,    11,     0,     0,    53,    84,     6,     0,    83,
     0,    15,    85,     0,     0,     0,     5,     0,    56,     0,
    12,    13,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    77,    76,     0,    54,    57,    58,    74,     0,
    86,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    33,     0,     0,    88,     0,     0,     0,     0,     0,     0,
     0,    21,    20,     0,    23,    90,    91,    92,    59,     0,
    60,     0,     0,     0,     0,    66,    61,    50,    55,    93,
    94,    16,    95,    96,    97,    98,     0,    99,    78,    82,
    81,     0,    72,    51,    71,    28,     0,     0,     0,     0,
     0,    32,    34,    24,    27,     0,    42,     0,     0,     0,
     0,     0,    41,    25,    62,    87,    64,     0,    86,     0,
     0,    80,   102,    79,     0,    75,    30,    31,     0,     0,
     0,     0,    44,    45,    46,    47,   106,     0,    39,    49,
     0,     0,     0,    37,    38,     0,   104,    35,     0,     0,
    99,    36,   101,   103,     0,   109,   107,     0,    63,    65,
    69,    67,    68,   100,    48,   110,   108,     0,     0,     0
};

static const short yydefgoto[] = {   188,
     2,    13,    14,    15,    16,    17,    53,    48,    19,    20,
    49,    70,    71,    72,    96,    21,    80,    81,    54,   159,
    23,    24,    25,    55,    56,    57,    89,    91,    97,    63,
    64,    59,    29,    26,    60,   135,    73,    27,    90,   165,
   172,   145,   168,   160,   178
};

static const short yypact[] = {    13,
-32768,   328,   169,    33,    33,    33,    -7,    33,    -7,-32768,
-32768,-32768,-32768,-32768,   190,-32768,-32768,-32768,-32768,    74,
-32768,-32768,-32768,    82,    83,-32768,-32768,-32768,   116,-32768,
   116,-32768,-32768,    87,    86,    99,-32768,   337,   374,   148,
-32768,-32768,    22,    33,    70,   337,   350,   115,   112,     4,
     4,   129,-32768,-32768,   113,   374,-32768,-32768,-32768,   269,
   145,   148,   133,   211,    22,     4,     4,   158,   158,   134,
-32768,   122,   153,-32768,    70,     4,     4,     4,     4,   141,
   136,-32768,-32768,   210,-32768,-32768,-32768,-32768,-32768,    33,
-32768,    33,    33,    33,    33,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   237,-32768,-32768,-32768,
-32768,    33,-32768,-32768,-32768,-32768,    33,    33,    33,    33,
    33,-32768,-32768,-32768,-32768,    33,-32768,    33,    33,    33,
    33,    20,-32768,-32768,   168,-32768,   172,    47,-32768,   302,
   296,-32768,-32768,-32768,    23,-32768,-32768,-32768,   375,   357,
   299,   159,-32768,-32768,-32768,-32768,-32768,    12,-32768,-32768,
    33,    33,    33,-32768,-32768,    33,-32768,-32768,    33,   253,
-32768,-32768,-32768,-32768,    33,-32768,-32768,    14,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   194,   200,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,     0,-32768,   154,   -41,     3,    30,-32768,-32768,
-32768,    -9,-32768,-32768,    29,-32768,    26,-32768,     9,-32768,
    54,-32768,-32768,   149,-32768,-32768,-32768,-32768,-32768,    91,
   -18,-32768,     2,   177,   -25,  -108,   -70,    -4,   170,   -46,
   144,-32768,   147,-32768,-32768
};


#define	YYLAST		406


static const short yytable[] = {    30,
    30,    30,    28,    30,    18,    18,    31,    32,   147,    35,
    22,    22,    33,   109,    37,     1,    12,    18,   108,   153,
    58,   137,    65,    22,    86,    87,    88,     4,     5,     6,
    66,    67,    68,    69,    61,    61,   176,    58,   186,    74,
    47,    10,    11,   177,   157,   187,    12,   148,    47,    47,
   158,    61,   179,   -29,   173,   116,    12,    61,   154,    61,
   144,   163,   125,   100,   101,   143,   185,   138,   140,   141,
    75,   103,   104,   105,   106,    82,    83,   164,    76,    77,
    78,    79,    41,   134,    42,   136,    18,    74,   139,   139,
   139,   180,    22,   149,   150,   151,   122,   123,   167,   171,
   127,   -43,    38,   174,   155,   156,   133,   146,   167,   171,
    39,    40,   136,    74,   139,   139,   139,    43,    44,     4,
     5,    30,    65,   136,    74,   139,   139,   152,   143,    45,
    66,    67,    68,    69,    11,    11,    75,   181,    12,    12,
   182,    85,    98,   183,    76,    77,    78,    79,    62,    93,
    94,    95,   113,   -26,   115,     7,   136,    74,   139,   112,
     8,   139,   114,     9,   139,   124,   126,   -40,    -7,     3,
   136,    12,   132,     4,     5,     6,     7,   -73,   119,   120,
   121,     8,   161,    34,     9,    36,   162,    10,    11,    -4,
     3,   175,    12,   189,     4,     5,     6,     7,    -7,   190,
     0,    84,     8,   110,    99,     9,   111,     0,    10,    11,
     3,    62,     0,    12,     4,     5,     6,     7,     7,    -4,
    92,     0,     8,     8,     0,     9,     9,     0,    10,    11,
     0,     0,     0,    12,    12,   117,   118,     0,     0,    -7,
   -70,     4,     5,     6,     0,   128,   129,   130,   131,     0,
     0,     0,     0,   100,   101,    10,    11,     4,     5,     6,
    12,   103,   104,   105,   106,     0,     0,     0,   142,     0,
     0,    10,    11,     4,     5,     6,    12,     0,     0,     0,
     0,     0,     0,     0,   184,   100,   101,   102,    11,     0,
     0,     0,    12,   103,   104,   105,   106,     0,     0,   107,
     4,     5,     6,     4,     5,     6,     4,     5,     6,     0,
   169,     0,     0,     0,    10,    11,   166,    10,    11,    12,
   102,    11,    12,     0,     0,    12,   170,    -7,     3,   170,
     0,     0,     4,     5,     6,     7,     0,    46,     0,     0,
     8,   -22,   -22,     9,     7,     0,    10,    11,     0,     0,
    46,    12,     9,     0,   -19,   -19,   -22,     7,     0,     0,
   -22,     4,     5,     6,     0,     9,     0,     0,     0,   -19,
     0,     0,     0,   -19,     0,   102,    11,     0,     0,     0,
    12,     7,    50,    51,    52,     0,     8,     0,     0,     9,
     0,   100,   101,     0,     0,     0,     0,    12,     0,   103,
   104,   105,   106,     0,     0,   164
};

static const short yycheck[] = {     4,
     5,     6,     3,     8,     2,     3,     5,     6,   117,     8,
     2,     3,    20,    60,    15,     3,    24,    15,    60,   128,
    39,    92,     1,    15,    21,    22,    23,     5,     6,     7,
     9,    10,    11,    12,    39,    40,    25,    56,    25,    44,
    38,    19,    20,    32,    25,    32,    24,   118,    46,    47,
    31,    56,   161,    32,    32,    65,    24,    62,   129,    64,
   107,    15,    72,    17,    18,   107,   175,    93,    94,    95,
     1,    25,    26,    27,    28,    46,    47,    31,     9,    10,
    11,    12,    29,    84,    31,    90,    84,    92,    93,    94,
    95,   162,    84,   119,   120,   121,    68,    69,   140,   141,
    75,    32,    29,   145,   130,   131,    81,   112,   150,   151,
    29,    29,   117,   118,   119,   120,   121,    31,    33,     5,
     6,   126,     1,   128,   129,   130,   131,   126,   170,    31,
     9,    10,    11,    12,    20,    20,     1,   163,    24,    24,
   166,    30,    30,   169,     9,    10,    11,    12,     1,    21,
    22,    23,    62,    32,    64,     8,   161,   162,   163,    15,
    13,   166,    30,    16,   169,    32,    14,    32,     0,     1,
   175,    24,    32,     5,     6,     7,     8,    30,    21,    22,
    23,    13,    15,     7,    16,     9,    15,    19,    20,     0,
     1,    33,    24,     0,     5,     6,     7,     8,    30,     0,
    -1,    48,    13,    60,    56,    16,    60,    -1,    19,    20,
     1,     1,    -1,    24,     5,     6,     7,     8,     8,    30,
    51,    -1,    13,    13,    -1,    16,    16,    -1,    19,    20,
    -1,    -1,    -1,    24,    24,    66,    67,    -1,    -1,    30,
    30,     5,     6,     7,    -1,    76,    77,    78,    79,    -1,
    -1,    -1,    -1,    17,    18,    19,    20,     5,     6,     7,
    24,    25,    26,    27,    28,    -1,    -1,    -1,    32,    -1,
    -1,    19,    20,     5,     6,     7,    24,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    32,    17,    18,    19,    20,    -1,
    -1,    -1,    24,    25,    26,    27,    28,    -1,    -1,    31,
     5,     6,     7,     5,     6,     7,     5,     6,     7,    -1,
    15,    -1,    -1,    -1,    19,    20,    15,    19,    20,    24,
    19,    20,    24,    -1,    -1,    24,    31,     0,     1,    31,
    -1,    -1,     5,     6,     7,     8,    -1,     1,    -1,    -1,
    13,     5,     6,    16,     8,    -1,    19,    20,    -1,    -1,
     1,    24,    16,    -1,     5,     6,    20,     8,    -1,    -1,
    24,     5,     6,     7,    -1,    16,    -1,    -1,    -1,    20,
    -1,    -1,    -1,    24,    -1,    19,    20,    -1,    -1,    -1,
    24,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
    -1,    17,    18,    -1,    -1,    -1,    -1,    24,    -1,    25,
    26,    27,    28,    -1,    -1,    31
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/opt/gnu/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE












#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/opt/gnu/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */









int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 56 "parser.bison"
{
	  Start();
	;
    break;}
case 6:
#line 64 "parser.bison"
{ yyerrok; ;
    break;}
case 8:
#line 67 "parser.bison"
{;
    break;}
case 9:
#line 68 "parser.bison"
{;
    break;}
case 10:
#line 69 "parser.bison"
{;
    break;}
case 11:
#line 72 "parser.bison"
{
	  if (yyvsp[0].node) AppendNode(yyvsp[0].node); yyval.node = yyvsp[0].node;
	;
    break;}
case 12:
#line 76 "parser.bison"
{
	  if (yyvsp[0].node) AppendNamedNode(yyvsp[-1].s, yyvsp[0].node); yyval.node = yyvsp[0].node;
	;
    break;}
case 13:
#line 80 "parser.bison"
{
	  if (yyvsp[0].node) DefineNamedNode(yyvsp[-1].s, yyvsp[0].node); yyval.node = yyvsp[0].node;
	;
    break;}
case 15:
#line 86 "parser.bison"
{
	  yyval.node = UseNamedNode(yyvsp[0].s);
	;
    break;}
case 16:
#line 90 "parser.bison"
{
	  yyval.node = 0;
        ;
    break;}
case 21:
#line 99 "parser.bison"
{yyerrok;;
    break;}
case 23:
#line 103 "parser.bison"
{
	  EndProto();
	;
    break;}
case 24:
#line 108 "parser.bison"
{
	  BeginProto(yyvsp[-3].s);
	;
    break;}
case 28:
#line 116 "parser.bison"
{yyerrok;;
    break;}
case 30:
#line 121 "parser.bison"
{
	  interface.append(new eventIn(yyvsp[0].s, yyvsp[-1].t));
	;
    break;}
case 31:
#line 125 "parser.bison"
{
	  interface.append(new eventOut(yyvsp[0].s, yyvsp[-1].t));
	;
    break;}
case 32:
#line 129 "parser.bison"
{
	  interface.append(new field(curId, curValue));
	;
    break;}
case 34:
#line 134 "parser.bison"
{
	  interface.append(new exposedField(curId, curValue));
	;
    break;}
case 35:
#line 140 "parser.bison"
{
	  curId = yyvsp[-1].s;
	  curValue = fieldValue(yyvsp[0].val);
	;
    break;}
case 36:
#line 145 "parser.bison"
{ 
	  curId = yyvsp[-1].s;
	  curValue = fieldValue(yyvsp[0].val);
	;
    break;}
case 37:
#line 150 "parser.bison"
{
	  UnputToken();
	  curId = yyvsp[-1].s;
	  curValue = ParseValue(yyvsp[-2].t);
	;
    break;}
case 38:
#line 156 "parser.bison"
{
	  UnputToken();
	  curId = yyvsp[-1].s;
	  curValue = ParseValue(yyvsp[-2].t);
	;
    break;}
case 39:
#line 163 "parser.bison"
{
	  NewExternProto(yyvsp[-4].s, yyvsp[0].strings);
	;
    break;}
case 42:
#line 169 "parser.bison"
{yyerrok;;
    break;}
case 44:
#line 173 "parser.bison"
{
	  interface.append(new eventIn(yyvsp[0].s, yyvsp[-1].t));
	;
    break;}
case 45:
#line 177 "parser.bison"
{
	  interface.append(new eventOut(yyvsp[0].s, yyvsp[-1].t));
	;
    break;}
case 46:
#line 181 "parser.bison"
{
	  interface.append(new field(yyvsp[0].s, fieldValue(yyvsp[-1].t)));
	;
    break;}
case 47:
#line 185 "parser.bison"
{
	  interface.append(new exposedField(yyvsp[0].s, fieldValue(yyvsp[-1].t)));
	;
    break;}
case 48:
#line 190 "parser.bison"
{
	  AddRoute(yyvsp[-6].s, yyvsp[-4].s, yyvsp[-2].s, yyvsp[0].s);
	;
    break;}
case 50:
#line 199 "parser.bison"
{ 
	  yyval.node = EndScript(); 
	;
    break;}
case 51:
#line 203 "parser.bison"
{
	  yyval.node = EndNodeInstance();
	;
    break;}
case 52:
#line 208 "parser.bison"
{ 
	  BeginScript(); 
	;
    break;}
case 53:
#line 213 "parser.bison"
{ 
	  BeginNodeInstance(yyvsp[0].s); 
	;
    break;}
case 62:
#line 230 "parser.bison"
{ 
	  AppendMember(new eventIn(yyvsp[0].s, yyvsp[-1].t)); 
	;
    break;}
case 63:
#line 234 "parser.bison"
{ 
	  AppendMember(new eventIn(yyvsp[-2].s, yyvsp[-3].t)); MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 64:
#line 239 "parser.bison"
{ 
	  AppendMember(new eventOut(yyvsp[0].s, yyvsp[-1].t)); 
	;
    break;}
case 65:
#line 243 "parser.bison"
{ 
	  AppendMember(new eventOut(yyvsp[-2].s, yyvsp[-3].t)); MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 66:
#line 248 "parser.bison"
{ 
	  AppendMember(new field(curId, curValue)); 
	;
    break;}
case 67:
#line 252 "parser.bison"
{ 
	  AppendMember(new field(yyvsp[-2].s, fieldValue(yyvsp[-3].t))); MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 68:
#line 256 "parser.bison"
{ 
	  AppendMember(new field(yyvsp[-2].s, fieldValue(yyvsp[-3].t))); MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 69:
#line 260 "parser.bison"
{ 
	  AppendMember(new field(yyvsp[-2].s, fieldValue(yyvsp[-3].t))); MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 72:
#line 266 "parser.bison"
{ yyerrok; ;
    break;}
case 75:
#line 271 "parser.bison"
{
	  MakeLink(yyvsp[-2].s, yyvsp[0].s); 
	;
    break;}
case 78:
#line 278 "parser.bison"
{ 
	  UnputToken(); NonNodeFieldIdValuePair(yyvsp[-1].s); 
	;
    break;}
case 79:
#line 282 "parser.bison"
{ 
	  UnputToken(); UnputString("["); NonNodeFieldIdValuePair(yyvsp[-2].s); 
	;
    break;}
case 80:
#line 286 "parser.bison"
{ 
	  UnputString("[]"); NonNodeFieldIdValuePair(yyvsp[-2].s); 
	;
    break;}
case 81:
#line 290 "parser.bison"
{ 
	  NodeFieldIdValuePair(yyvsp[-1].s, yyvsp[0].val); 
	;
    break;}
case 82:
#line 294 "parser.bison"
{ 
	  NodeFieldIdValuePair(yyvsp[-1].s, yyvsp[0].val); 
	;
    break;}
case 85:
#line 302 "parser.bison"
{
	   yyval.s = "Script"; 
	;
    break;}
case 93:
#line 320 "parser.bison"
{;
    break;}
case 94:
#line 320 "parser.bison"
{;
    break;}
case 95:
#line 320 "parser.bison"
{;
    break;}
case 96:
#line 320 "parser.bison"
{;
    break;}
case 97:
#line 320 "parser.bison"
{;
    break;}
case 98:
#line 320 "parser.bison"
{;
    break;}
case 99:
#line 323 "parser.bison"
{
	  fieldValue val = new MFNode; if (yyvsp[0].node) ((MFNode*)val)->append(yyvsp[0].node); yyval.val = val; 
	;
    break;}
case 100:
#line 327 "parser.bison"
{ 
	  fieldValue val = new MFNode; yyval.val = val; 
	;
    break;}
case 101:
#line 331 "parser.bison"
{ 
	  fieldValue val = yyvsp[-1].nodes; yyval.val = val; 
	;
    break;}
case 102:
#line 336 "parser.bison"
{ 
	  yyval.nodes = new MFNode; if (yyvsp[0].node) yyval.nodes->append(yyvsp[0].node); 
	;
    break;}
case 103:
#line 340 "parser.bison"
{
	  yyval.nodes = yyvsp[-1].nodes; if (yyvsp[0].node) yyval.nodes->append(yyvsp[0].node); 
	;
    break;}
case 104:
#line 345 "parser.bison"
{
	   fieldValue val = new SFNode *(yyvsp[0].node); yyval.val = val; 
	;
    break;}
case 105:
#line 349 "parser.bison"
{ 
	  fieldValue val = new SFNode *(0); yyval.val = val; 
	;
    break;}
case 106:
#line 354 "parser.bison"
{ 
	  yyval.strings = new MFString; yyval.strings->append((SFString)yyvsp[0].s); 
	;
    break;}
case 107:
#line 358 "parser.bison"
{ 
	  yyval.strings = new MFString; 
	;
    break;}
case 108:
#line 362 "parser.bison"
{ 
	  yyval.strings = yyvsp[-1].strings; 
	;
    break;}
case 109:
#line 367 "parser.bison"
{ 
	  yyval.strings = new MFString; yyval.strings->append((SFString)yyvsp[0].s); 
	;
    break;}
case 110:
#line 371 "parser.bison"
{ 
	  yyval.strings = yyvsp[-1].strings; yyval.strings->append((SFString)yyvsp[0].s); 
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/opt/gnu/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 375 "parser.bison"


}  // namespace vrml2_utf8
